classification
Title: Support for opening files with FILE_SHARE_DELETE on Windows
Type: enhancement Stage: patch review
Components: Library (Lib) Versions: Python 3.5
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: Nosy List: BreamoreBoy, dabrahams, eryksun, loewis, ncoghlan, piotr.dobrogost, pitrou, r.david.murray, sbt, steve.dower, tim.golden, zach.ware
Priority: normal Keywords: patch

Created on 2012-07-03 19:14 by sbt, last changed 2015-03-24 18:04 by eryksun.

Files
File name Uploaded Description Edit
share.patch sbt, 2012-07-03 19:14 review
Messages (11)
msg164616 - (view) Author: Richard Oudkerk (sbt) * (Python committer) Date: 2012-07-03 19:14
On Unix, files (unless specifically locked) can be renamed and deleted while file descriptors for the file remain open.  The file descriptors remain valid even after deletion of the file.

On Windows this is not possible for files opened using io.open() or os.open().  However, by using the FILE_SHARE_DELETE flag in CreateFile() one can get Unix-like behaviour.

Unfortunately, FILE_SHARE_DELETE is only available through the Win32 API, not through the CRT.  Also, Issue #14243 concerns the fact that on Windows temporary files cannot be reopened unless one uses the FILE_SHARE_DELETE flag.  One can only reopen a file by using a share mode that is at least as permissive as the share mode for all the currently open handles.

The attached patch adds a module "share" (bad name?) with functions share.open() and share.os_open() which act as substitutes for io.open() and os.open().  These by default use FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE as the share mode.  (io.open() and os.open() use FILE_SHARE_READ | FILE_SHARE_WRITE instead.)

To run the full regression test suite with builtins.open(), io.open() and os.open() monkey patched to use these replacements you can do

    python -m test.test_share --regrtest

Nothing seems to break.
msg184087 - (view) Author: Piotr Dobrogost (piotr.dobrogost) Date: 2013-03-13 15:33
Having the same semantics on both Unix and Windows with regard to validity of file handle after a file was deleted would be a very nice to have. How could we progress this?

I'm adding Martin and Antoine to cc list.
msg184089 - (view) Author: Richard Oudkerk (sbt) * (Python committer) Date: 2013-03-13 16:03
Actually, it is not quite the same semantics as Unix.

After you delete the the file you cannot create a file of the same name or delete the directory which contains it until the handle has been closed.

However, one can work around that by moving the file somewhere else (like the root directory) before deleting it.
msg184129 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2013-03-14 02:43
I don't understand whether you are proposing to include the patch into Python as-is; if so, I'm -1 on it for two formal reasons: a) the standard library shouldn't monkey patch itself, and b) OS interfacing should be implemented in C.

That said, having maximum sharing when opnening files sounds fine to me.
msg184158 - (view) Author: Piotr Dobrogost (piotr.dobrogost) Date: 2013-03-14 10:31
> I don't understand whether you are proposing to include the patch into Python as-is;

I think Richard is well aware of the constraints you specify and current patch was meant as a proof of concept; to show that all tests pass with such a change. Of course that's only my belief and we shall see what Richard has to say.

> That said, having maximum sharing when opnening files sounds fine to me.

Good to hear. However I started to wonder if we are ready for all consequences of this. For example taking into account what Richard noted in http://bugs.python.org/issue14243, specifically:

> Unfortunately using O_TEMPORARY is the only way allowed by msvcrt to
> get FILE_SHARE_DELETE, even though it also has the orthogonal effect
> of unlinking the file when all handles are closed.

forces programs which would like to open a file being opened at the same time by Python code (by means of built-in open() or os.open() with default arguments) to either use O_TEMPORARY when using msvcrt or to go low level and use CreateFile() Win32 API function with FILE_SHARE_DELETE flag. Are we ok with it?
msg184162 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2013-03-14 13:00
Am 14.03.13 03:31, schrieb Piotr Dobrogost:
> forces programs which would like to open a file being opened at the
> same time by Python code (by means of built-in open() or os.open()
> with default arguments) to either use O_TEMPORARY when using msvcrt
> or to go low level and use CreateFile() Win32 API function with
> FILE_SHARE_DELETE flag. Are we ok with it?

That's why I was asking for an actual patch. The proposed change may
well not be implementable. If os.open continues to create CRT handles,
a way needs to be found to get a CRT handle that as the
FILE_SHARE_DELETE bit set.

An alternative approach could be that os.open stops creating CRT
handles, and directly uses OS handles. The problem with that is that
stdin/stdout/stderr would stop being 0/1/2, which is not acceptable.
An alternative solution to that could be that we introduce a notion
of "python io handles", parallel, but indepedendent from CRT handles.
And so on.
msg184164 - (view) Author: Richard Oudkerk (sbt) * (Python committer) Date: 2013-03-14 14:37
On 14/03/2013 1:00pm, Martin v. Löwis wrote:
> That's why I was asking for an actual patch. The proposed change may
> well not be implementable. If os.open continues to create CRT handles,
> a way needs to be found to get a CRT handle that as the
> FILE_SHARE_DELETE bit set.

The patch *does* create CRT fds from win32 handles by using 
msvcrt.open_osfhandle().

One other issue is that I do not know of a way to determine the current 
umask without temporarily changing it, causing a thread-race.

In the end I am not sure it is worth the hassle.  (But maybe it would be 
a good idea to add test.support.open() using FILE_SHARE_DELETE and 
test.support.unlink() to make the testsuite more resilient to 
"Permission Denied" errors.)

> An alternative approach could be that os.open stops creating CRT
> handles, and directly uses OS handles. The problem with that is that
> stdin/stdout/stderr would stop being 0/1/2, which is not acceptable.
> An alternative solution to that could be that we introduce a notion
> of "python io handles", parallel, but indepedendent from CRT handles.
> And so on.

http://bugs.python.org/issue12939 has C implementations of _io.WinFileIO 
and _io.openhandle() which are equivalents for _io.FileIO and os.open() 
which use "native" Windows handles.
msg228368 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2014-10-03 20:23
How do we take this forward, also considering #12939, #21859 and #14243 and possibly others?
msg228380 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2014-10-03 21:07
As much as I like the idea of using OS handles everywhere, the compatibility issues are probably too significant, and you can't mix CRT methods with OS methods because the CRT does its own buffering. Of course, you can open a file with the Win32 API and immediately call open_osfhandle() safely enough.

It seems this should be solvable with the opener argument of open(). Was that discussed and I missed it? Would the ability to write "open(f, opener=with_same_sharing_as(f))" be okay/useful/relevant for all platforms?
msg228437 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2014-10-04 08:02
"opener" was new in 3.3, so I suspect it didn't come up because *we're* still not entirely accustomed to having it available yet :)

I agree providing a suitable opener could be a good way to go.
msg239163 - (view) Author: Eryk Sun (eryksun) * (Python triager) Date: 2015-03-24 18:04
> you can't mix CRT methods with OS methods because the CRT does its 
> own buffering

Python 3's io uses the CRT's low I/O (ioinfo struct) in binary mode. It appears that the buffers pipech, pipech2, and dbcsbuffer are only used in text mode. So it should be generally OK to call get_osfhandle and use Win32 directly, if that's ever required. 

Of course, as this patch demonstrates, an io opener (3.3+) can call open_osfhandle immediately after CreateFile, and nothing else changes. This could be added to io / _pyio in 3.5. Initially it could simply be a pure-Python function that uses _winapi and msvcrt. 3.6 could get a C implementation in _iomodule.c.
History
Date User Action Args
2015-03-24 18:04:49eryksunsetnosy: + eryksun
messages: + msg239163
2014-10-04 08:08:10r.david.murraysetnosy: + r.david.murray
2014-10-04 08:02:49ncoghlansetmessages: + msg228437
2014-10-03 21:07:55steve.dowersetmessages: + msg228380
2014-10-03 20:23:26BreamoreBoysetnosy: + tim.golden, BreamoreBoy, zach.ware, steve.dower

messages: + msg228368
versions: + Python 3.5, - Python 3.4
2013-03-14 14:37:13sbtsetmessages: + msg184164
2013-03-14 13:00:37loewissetmessages: + msg184162
2013-03-14 10:31:01piotr.dobrogostsetmessages: + msg184158
2013-03-14 02:43:13loewissetmessages: + msg184129
2013-03-13 16:03:35sbtsetmessages: + msg184089
2013-03-13 15:42:09piotr.dobrogostsetnosy: + ncoghlan, dabrahams
2013-03-13 15:33:10piotr.dobrogostsetnosy: + loewis, pitrou
messages: + msg184087
2013-03-06 10:03:46piotr.dobrogostsetnosy: + piotr.dobrogost
2012-07-03 19:14:54sbtcreate